// ThreadsAndProcessesDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ThreadsAndProcesses.h"
#include "ThreadsAndProcessesDlg.h"
#include "afxmt.h"						// for the critical sections

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CThreadsAndProcessesDlg dialog

CThreadsAndProcessesDlg::CThreadsAndProcessesDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CThreadsAndProcessesDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CThreadsAndProcessesDlg)
	/*fData*/xxx = _T("");
	fTwoThreadsCounter = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CThreadsAndProcessesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CThreadsAndProcessesDlg)
	//DDX_Text(pDX, IDC_EDIT_DATA, xxx);
	DDX_Text(pDX, IDC_EDIT_TWO_THREADS_COUNTER, fTwoThreadsCounter);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CThreadsAndProcessesDlg, CDialog)
	//{{AFX_MSG_MAP(CThreadsAndProcessesDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_THREAD2, OnButtonThread2)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CThreadsAndProcessesDlg message handlers

BOOL CThreadsAndProcessesDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	for( int i = 0; i < kMaxThreads; ++ i )
		myThreadsArray[ kMaxThreads ] = 0;

	SetTimer( 1, 100, 0);			// each 500 ms call our handler

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CThreadsAndProcessesDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CThreadsAndProcessesDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CThreadsAndProcessesDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}



/////////////////////////////////////////////////////////////////////////////////////


CCriticalSection  gTheCriticalSection;

long gTheCounter;

UINT MyMultiThreadFunction( LPVOID pParam )
{
	bool finishTheThread = false;

	while( finishTheThread == false )
	{
		// Try to enter to the critical section
		if( gTheCriticalSection.Lock( 0 /*this is timeout but ignored by this object*/ ) != 0 )
		{
			// Here we are :)
			
			if( * (long*)pParam < LONG_MAX )
			{
				++ ( * (long*)pParam );		// update the submitted parameter
			}
			else
			{
				finishTheThread = true;
			}

		}

		// Allow the other threads to access the resource
		gTheCriticalSection.Unlock();
	}

	return 0;
}




void CThreadsAndProcessesDlg::OnButtonThread2() 
{
	AfxBeginThread( MyMultiThreadFunction, & gTheCounter );
	AfxBeginThread( MyMultiThreadFunction, & gTheCounter );
	AfxBeginThread( MyMultiThreadFunction, & gTheCounter );
	AfxBeginThread( MyMultiThreadFunction, & gTheCounter );
	AfxBeginThread( MyMultiThreadFunction, & gTheCounter );
	AfxBeginThread( MyMultiThreadFunction, & gTheCounter );
	AfxBeginThread( MyMultiThreadFunction, & gTheCounter );

}

// To update the controls
void CThreadsAndProcessesDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	CDialog::OnTimer(nIDEvent);

	fTwoThreadsCounter = gTheCounter;
	UpdateData( FALSE );

}

/////////////////////////////////////////////////////////////////////////////////////


void CThreadsAndProcessesDlg::OnDestroy() 
{
	
	// TODO: Add your message handler code here
	KillTimer( 1 );

	CDialog::OnDestroy();
}


